module Aufgabe_01 exposing (..)

import Html exposing (text, ul, li)
import List exposing (map)

euro : List Int
euro = [50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 2, 1]

input : Int
input = 4711


change : Int -> List Int -> Result String (List Int)
change amount currency =
    if amount == 0 then Ok []

    else
        case currency of
            head :: tail ->
                if head < amount then
                    case change (amount - head) currency of
                        Err message -> Err message
                        Ok rest -> Ok (head :: rest)

                else change amount tail
            [] -> Err "Kein Wechselgeld"


main = case change input euro of
            Ok changed -> ul [] (map (\x -> li [] [(text (String.fromInt x))]) changed)
            Err message -> text message
