module Aufgabe_01_3 exposing (..)

import Html

euro : List Int
euro = [50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 2, 1]

change : Int -> List Int -> Result String (List Int)
change amount currency =
    if amount <= 0
    then Ok []
    else case currency of
             [] -> Err "No change available"
             head :: tail ->
                 if head <= amount
                 then case change (amount - head) currency of
                          Ok c -> Ok (head :: c)
                          Err msg -> Err msg
                 else change amount tail


result = change 7563 euro
main = case result of
           Err msg -> Html.text msg
           Ok money -> Html.ul [] (List.map (\x -> Html.li [] [Html.text (String.fromInt x)]) money)
