module Aufgabe_01_2 exposing (..)

import Html

euro : List Int
euro = [50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 2, 1]


wechseln : Int -> List Int -> Result String (List Int)
wechseln geldMenge waehrung =
    if geldMenge <= 0 then Ok []
    else case waehrung of
             head :: tail -> if head <= geldMenge
                        then case wechseln (geldMenge - head) waehrung of
                                 Err msg -> Err msg
                                 Ok wechselgeld -> Ok (head :: wechselgeld)
                        else wechseln geldMenge tail
             [] -> Err "Kein Wechselgeld"


result = wechseln 4711 euro

main = case result of
           Ok wechselgeld -> Html.ul [] (List.map (\x -> Html.li [] [Html.text (String.fromInt x)]) wechselgeld)
           Err msg -> Html.text msg

