module Aufgabe_Complex_Type exposing (..)

type Complex = Complex Float Float

fromTuple : (Float, Float) -> Complex
fromTuple (r, i) = Complex r i

fromFloat : Float -> Complex
fromFloat r = Complex r 0

real : Complex -> Float
real c = case c of Complex r i -> r

imaginary : Complex -> Float
imaginary c = case c of Complex r i -> i
